--- postinst.old	2012-12-30 23:44:27.537179984 -0500
+++ postinst	2012-12-31 00:41:22.250090217 -0500
@@ -119,8 +119,8 @@ if [ "$1" = "configure" ]; then
 
   ## SSL Certs
   # Certs and key file
-  OLD_SSL_CERT="/etc/ssl/certs/dovecot.pem"
-  OLD_SSL_KEY="/etc/ssl/private/dovecot.pem"
+  OLD_SSL_CERT=$(perl -ne 'print $1 and exit if m/^\s*ssl_cert+\s*=\s*<(\S+)/' /etc/dovecot/conf.d/10-ssl.conf)
+  OLD_SSL_KEY=$(perl -ne 'print $1 and exit if m/^\s*ssl_key+\s*=\s*<(\S+)/' /etc/dovecot/conf.d/10-ssl.conf)
   SSL_CERT="/etc/dovecot/dovecot.pem"
   SSL_KEY="/etc/dovecot/private/dovecot.pem"
 
@@ -128,24 +128,15 @@ if [ "$1" = "configure" ]; then
     install -d -o root -g root -m0700 /etc/dovecot/private
   fi
 
-  if [ -e $OLD_SSL_CERT ] || [ -e $OLD_SSL_KEY ]; then
+  if [ "$OLD_SSL_CERT" = "$SSL_CERT" ] && [ -e $SSL_CERT ] && [ "$OLD_SSL_KEY" = "$SSL_KEY" ] && [ -e $SSL_KEY ]; then
+      echo "You already have ssl certs for dovecot."
+  elif ([ -n $OLD_SSL_CERT ] && [ -e $OLD_SSL_CERT ]) || ([ -n $OLD_SSL_KEY ] && [ -e $OLD_SSL_KEY ]); then
       echo "You already have ssl certs for dovecot."
       echo "However you should move them out of /etc/ssl"
       echo "and into /etc/dovecot and update the configuration"
       echo "in /etc/dovecot/conf.d/10-ssl.conf accordingly."
       echo "See /usr/share/doc/dovecot-core/NEWS.Debian.gz for details."
-        perl -i -nE "
-        if (/^\w*?ssl_cert/) {
-            say 'ssl_cert = <$OLD_SSL_CERT'
-        }
-        elsif (/^\w*?ssl_key/) {
-            say 'ssl_key = <$OLD_SSL_KEY'
-        } else {
-            print;
-        }" /etc/dovecot/conf.d/10-ssl.conf
   # Generate new certs if needed
-  elif [ -e $SSL_CERT ] || [ -e $SSL_KEY ]; then
-      echo "You already have ssl certs for dovecot."
   else
       echo "Creating generic self-signed certificate: $SSL_CERT"
       echo "This certificate will expire in 10 years."
